local Compost = AceLibrary("Compost-2.0")

--The List of frames to check against.
local FrameList = {
	action = {
		{ "ActionButton", 12 },
		{ "BonusActionButton", 12 },
		{ "MultiBarBottomLeftButton", 12 },
		{ "MultiBarBottomRightButton", 12 },
		{ "MultiBarRightButton", 12 },
		{ "MultiBarLeftButton", 12 },
	},
	shapeshift = {
		{ "ShapeshiftButton", 10 },
	},
	pet = {
		{ "PetActionButton", 10 },
	},
}

local FrameId = {
	action = function (name, id)
		local b = getglobal (name)
		if b and b:IsVisible () then
			return ActionButton_GetPagedID (b)
		end
	end,
	shapeshift = function (name, id) 
		if GetNumShapeshiftForms () >= id then
			return id
		end
	end,
	pet = function (name, id)
		if PetHasActionBar() and GetPetActionInfo(id) then
			return id
		end
	end,
}

local function Default_Buttons_UpdateCountList(list)
	for type, l in pairs(FrameList) do
		for _, frames in ipairs(l) do
			for i = 1, frames[2] do
				local name = frames[1]..i
				local id = FrameId[type] (name, i)
				if id then
					list[name.."Count"] = Compost:AcquireHash("type", type, "id", id)
				end
			end
		end
	end
end

--Make lern2count aware of this plugin
ltc:RegisterPlugin(Default_Buttons_UpdateCountList)
